/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package Test;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.rmi.RemoteException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;

import javax.xml.rpc.ServiceException;
import org.apache.axis.message.MessageElement;
import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFCellStyle;
import org.apache.poi.hssf.usermodel.HSSFFont;
import org.apache.poi.hssf.usermodel.HSSFRichTextString;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import com.microsoft.schemas.office.project.server.webservices.LoginForms.LoginFormsLocator;
import com.microsoft.schemas.office.project.server.webservices.LoginForms.LoginFormsSoap;
import com.microsoft.schemas.office.project.server.webservices.LoginForms.LoginFormsSoapStub;
import com.microsoft.schemas.office.project.server.webservices.Project.DataStoreEnum;
import com.microsoft.schemas.office.project.server.webservices.Project.ProjectLocator;
import com.microsoft.schemas.office.project.server.webservices.Project.ProjectSoap;
import com.microsoft.schemas.office.project.server.webservices.Project.ProjectSoapStub;
import com.microsoft.schemas.office.project.server.webservices.Project.ReadProjectListResponseReadProjectListResult;
import com.microsoft.schemas.office.project.server.webservices.Project.ReadProjectResponseReadProjectResult;

@SuppressWarnings("unused")

public class Completed_Test {

	static String progetto_corrente = "";
	static String metafase_corrente = "";

	public static void main(String[] args) throws Exception {

		String username = "salier@engitest.it";
		String password = "Nicola11";

		String[] useful = {"Project_Name","Metafase_Name","Metafase_code","Phase_Type",
				"PROJ_UID","TASK_PARENT_UID","TASK_UID","TASK_NAME",
				"TASK_DUR","TASK_DUR_VAR","TASK_EAC","TASK_VAC",
				"TASK_ACT_DUR","TASK_REM_DUR","TASK_PCT_COMP","TASK_PCT_WORK_COMP",
				"TASK_WORK","TASK_ACT_WORK","TASK_REM_WORK","TASK_COST",
				"TASK_ACT_COST","TASK_REM_COST","TB_COST","TB_WORK",
				"TB_DUR","TASK_BCWS","TASK_BCWP","TASK_ACWP",
				"TASK_WBS","TASK_COST_VAR","TASK_CPI","TASK_CV",
				"TASK_SV","TASK_TCPI","TASK_WORK_VAR"};		

		//		String[] useful1 = {"TASK_NAME"};		

		int parameter;
		if (args.length == 0)
			parameter = 3;
		else
			parameter = Integer.parseInt(args[0]);

		String cookie = loginFormsWS(username, password);
		projWS(cookie, useful, parameter);			
	}

	/** LoginForms Web service to log on and log off users with Project Server authentication */
	public static String loginFormsWS(String user, String pw) {
		try {				
			LoginFormsLocator locator = new LoginFormsLocator();
			LoginFormsSoap loginSoap = locator.getLoginFormsSoap();
			LoginFormsSoapStub loginStub = (LoginFormsSoapStub)loginSoap;	
			locator.setMaintainSession(true);	



			System.out.println("->Before Logging");
			boolean logged = loginStub.login(user, pw);	
			String[] TempCookie = (String[])loginStub._getCall().getMessageContext().getProperty("Cookie");	
			if (logged) {
				System.out.println("-->Login success");			
			}
			else
				System.out.println("-->Login failed");		


			String cookie = TempCookie[0];		
			return cookie;
		} catch (RemoteException e) {
			e.printStackTrace();
			return null;
		} catch (ServiceException a) {
			a.printStackTrace();
			return null;
		}
	}	

	/** Tramite projWS  possibile risalire agli id dei progetti esistenti 
	 *  e a tutte le informazioni che contengono */
	public static void projWS (String cookie, String[] useful, int parameter) {
		try {
			ProjectLocator proj = new ProjectLocator();
			ProjectSoap projSoap = proj.getProjectSoap();
			ProjectSoapStub projStub = (ProjectSoapStub)projSoap;		
			proj.setMaintainSession(true);
			projStub.setCookie(cookie);

			/** ArrayList di HashMap per contenere gli elementi di interesse del progetto */
			ArrayList<HashMap<String,String>> array = new ArrayList<HashMap<String,String>>();
			HashMap<String,String> map;


			/** Elenco dei progetti inseriti nel Server */
			ReadProjectListResponseReadProjectListResult temp = projStub.readProjectList();
			System.out.println("--->Project Web Service called");
			MessageElement[] result = temp.get_any();							
			Element res = result[1];

			//Estrae gli elementi che hanno come TagName "PROJ_UID" e quindi contengono 
			//gli ID dei progetti inseriti ne database del server
			NodeList list = res.getElementsByTagName("PROJ_UID");			
			String[] projects = new String[2];
			for (int i=0; i<list.getLength(); i++) {
				projects[i] = list.item(i).getChildNodes().item(0).getNodeValue();
			}	

			/** Dati di ciascun progetto */

			ReadProjectResponseReadProjectResult project_1 = projStub.readProject(projects[0], DataStoreEnum.fromString("WorkingStore"));
			result = project_1.get_any();			
			res = result[1];
			//Stampa su file i dati di progetto
//			printFile("C:\\Test\\Project_1.xml", result[1].getAsString());	


			//Estrazione dei dati di interesse (evidenziati in giallo
			//nel foglio excel) e inserimento nella HashMap<String,Object> map
			list = res.getElementsByTagName("TASK_NAME");			
			for (int i=0; i<list.getLength(); i++) {
				Node nodo = list.item(i);
				if (parameter == 1) {
					if ((checkType(nodo)).equals("Progetto")) {						
						map = new HashMap<String,String>();
						populateMap(map, nodo, useful);
						array.add(map);
						break;
					}
				}
				else if (parameter == 3) {
					map = new HashMap<String,String>();
					populateMap(map, nodo, useful);
					array.add(map);
				}
				else if (!((checkType(nodo)).equals("Task"))) {
					map = new HashMap<String,String>();
					populateMap(map, nodo, useful);
					array.add(map);
				}
			}
			System.out.println("---->Elements inserted into ArrayList");
			printArrayList("C:\\Test\\ArrayList.txt", array);

			createXLS(array, useful);
			System.out.println("----->Table file created!");

			
			//Creazione della tabella in MySQL
			Class.forName("com.mysql.jdbc.Driver").newInstance();
			Connection conn = DriverManager.getConnection("jdbc:mysql://localhost:3306/test", "root", "admin");
			System.out.println("------>DB Connected");
			createTables(conn, useful);
			System.out.println("------>Table created");
			insertTables(conn, array, useful);
			System.out.println("------->Table data inserted");

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/** Riempie la HashMap corrente con gli elementi del task corrente */
	public static void populateMap(HashMap<String, String> map, Node nodo, String[] useful) {
		NodeList list = nodo.getParentNode().getChildNodes();
		for (int i=0; i<list.getLength(); i++) {
			String tmp = list.item(i).getNodeName();
			if (search(useful, tmp)) 
				map.put(list.item(i).getNodeName(), list.item(i).getChildNodes().item(0).getNodeValue());
		}
		map.put("Phase_Type", checkType(nodo));
		String sub = "null";
		if ((checkType(nodo)).equals("Progetto")) {
			progetto_corrente = nodo.getChildNodes().item(0).getNodeValue();
			metafase_corrente = nodo.getChildNodes().item(0).getNodeValue();
		}
		else if ((checkType(nodo)).equals("Metafase")) {
			metafase_corrente = nodo.getChildNodes().item(0).getNodeValue();
			String tmp = (String)map.get("TASK_NAME");
			if (tmp.indexOf("-") != -1)
				sub = tmp.substring(0, tmp.indexOf("-"));
			else
				sub = tmp.substring(0, tmp.indexOf(" "));
			map.put("Metafase_code", sub);
		}
		if (sub.equals("null"))
			map.put("Metafase_code", null);
		map.put("Project_Name", progetto_corrente);
		map.put("Metafase_Name", metafase_corrente);
	}

	/** Cerca solo gli elementi di interesse tra tutti quelli presenti nella struttura */
	public static boolean search(String[] use, String str) {
		for (int i=0; i<use.length; i++) {
			if (use[i].equals(str))
				return true;
		}
		return false;
	}

	/** Controlla il tipo di elemento */
	public static String checkType(Node nodo) {
		//Controlla se  una metafase
		String phase_name = nodo.getChildNodes().item(0).toString();
		if (phase_name.startsWith("AA"))
			return "Metafase";
		else { 
			//Controlla se  il nodo radice
			NodeList figli = nodo.getParentNode().getChildNodes();
			String proj_id = figli.item(1).getChildNodes().item(0).getNodeValue();
			String parent_id = figli.item(2).getChildNodes().item(0).getNodeValue();		
			if (proj_id.equals(parent_id))
				return "Progetto";
			else
				//Altrimenti  un semplice Task
				return "Task";
		}
	}

	/** Stampa sul file 'filename' l'arraylist list */
	public static void printArrayList(String filename, ArrayList<HashMap<String,String>> list) {
		String file = filename;
		try {			
			FileOutputStream stream = new FileOutputStream(file);
			File f = new File(file);
			FileOutputStream fop = new FileOutputStream(f);			
			String tmp;
			Iterator<HashMap<String,String>> it = list.iterator();
			while (it.hasNext()) {
				tmp = "" + it.next().toString() + "\n\n";
				fop.write(tmp.getBytes());
				fop.flush();
			}
			fop.close(); 
			System.out.println("----->Writing ArrayList to file " + file + " completed!");
		} catch (Exception e) {
			System.err.println(e);
			System.exit(1);
		}
	}

	/** Stampa sul file 'filename' il parametro 'data' */
	public static void printFile(String filename, String data) {
		String file = filename;
		try {			
			FileOutputStream stream = new FileOutputStream(file);
			File f = new File(file);
			FileOutputStream fop = new FileOutputStream(f);			
			if (file.endsWith("xml")) {
				String begin = "<?xml version=\"1.0\" encoding=\"utf-8\"?>";
				fop.write(begin.getBytes());
			}
			fop.write(data.getBytes());
			fop.flush();
			fop.close(); 
			System.out.println("----->Writing to file " + file + " completed!");
		} catch (Exception e) {
			System.err.println(e);
			System.exit(1);
		}
	}

	/** Crea la tabella XLS in Excel */
	public static void createXLS(ArrayList<HashMap<String,String>> list, String[] useful) {
		try {
			FileOutputStream out = new FileOutputStream("C:\\Test\\ArrayList.xls");
			HSSFWorkbook wb = new HSSFWorkbook();
			HSSFSheet s = wb.createSheet();
			HSSFRow r = null;
			HSSFCell c = null;

			HSSFCellStyle cs = wb.createCellStyle();
			HSSFFont f = wb.createFont();
			f.setBoldweight(HSSFFont.BOLDWEIGHT_BOLD);
			cs.setFont(f);

			s.setDefaultColumnWidth(35);

			for (int rows=0; rows<=list.size(); rows++) {
				r = s.createRow(rows);
				for (int columns=0; columns<list.get(0).size(); columns++) {
					c = r.createCell(columns);
					if (rows==0) {
						c.setCellStyle(cs);
						c.setCellValue(new HSSFRichTextString(useful[columns]));
					}
					else {
						if (list.get(rows-1).containsKey(useful[columns]))
							c.setCellValue(new HSSFRichTextString(list.get(rows-1).get(useful[columns])));
						else
							c.setCellValue(new HSSFRichTextString("null"));
					}
				}
			}		
			wb.write(out);
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}

	}

	/** Crea la tabella in MySQL */
	public static void createTables(Connection conn, String[] useful) {
		Statement stmt;		
		try {
			String drop = "drop table if exists Test_Projects;";
			stmt = conn.createStatement();
			stmt.executeUpdate(drop);
			stmt.close();
			String query = "create table Test_Projects (";
			for (int i=0; i<useful.length; i++) {
				if (i!=useful.length - 1)
					query = query + useful[i] + " varchar(70), ";
				else
					query = query + useful[i] + " varchar(70));";
			}
			stmt = conn.createStatement();
			stmt.executeUpdate(query);
			stmt.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/** Inserisce i dati nella tabella */
	public static void insertTables(Connection conn, ArrayList<HashMap<String,String>> list, String[] useful) {
		String query;
		Statement stmt;
		try {
			stmt = conn.createStatement();
			String tmp;
			query = "insert into Test_Projects values ";
			for (int i=0; i<list.size(); i++) {
				query = query + "(";		
				for (int j=0; j<list.get(0).size(); j++) {
					tmp = list.get(i).get(useful[j]);
					if (j<list.get(0).size() - 1)
						query = query + "'" + tmp + "', ";
					else
						query = query + "" + tmp + ")";
				}
				if (i<list.size()-1) 
					query = query + ",";				
				else
					query = query + ";";
			}			
			stmt.executeUpdate(query);
			stmt.close();
			conn.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}

