package com.microsoft.schemas.office.project.server.webservices.Project;

public class ProjectSoapProxy implements com.microsoft.schemas.office.project.server.webservices.Project.ProjectSoap {
  private String _endpoint = null;
  private com.microsoft.schemas.office.project.server.webservices.Project.ProjectSoap projectSoap = null;
  
  public ProjectSoapProxy() {
    _initProjectSoapProxy();
  }
  
  public ProjectSoapProxy(String endpoint) {
    _endpoint = endpoint;
    _initProjectSoapProxy();
  }
  
  private void _initProjectSoapProxy() {
    try {
      projectSoap = (new com.microsoft.schemas.office.project.server.webservices.Project.ProjectLocator()).getProjectSoap();
      if (projectSoap != null) {
        if (_endpoint != null)
          ((javax.xml.rpc.Stub)projectSoap)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
        else
          _endpoint = (String)((javax.xml.rpc.Stub)projectSoap)._getProperty("javax.xml.rpc.service.endpoint.address");
      }
      
    }
    catch (javax.xml.rpc.ServiceException serviceException) {}
  }
  
  public String getEndpoint() {
    return _endpoint;
  }
  
  public void setEndpoint(String endpoint) {
    _endpoint = endpoint;
    if (projectSoap != null)
      ((javax.xml.rpc.Stub)projectSoap)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
    
  }
  
  public com.microsoft.schemas.office.project.server.webservices.Project.ProjectSoap getProjectSoap() {
    if (projectSoap == null)
      _initProjectSoapProxy();
    return projectSoap;
  }
  
  public void checkOutProject(java.lang.String projectUid, java.lang.String sessionUid, java.lang.String sessionDescription) throws java.rmi.RemoteException{
    if (projectSoap == null)
      _initProjectSoapProxy();
    projectSoap.checkOutProject(projectUid, sessionUid, sessionDescription);
  }
  
  public void queueCheckInProject(java.lang.String jobUid, java.lang.String projectUid, boolean force, java.lang.String sessionUid, java.lang.String sessionDescription) throws java.rmi.RemoteException{
    if (projectSoap == null)
      _initProjectSoapProxy();
    projectSoap.queueCheckInProject(jobUid, projectUid, force, sessionUid, sessionDescription);
  }
  
  public void queueCreateProject(java.lang.String jobUid, com.microsoft.schemas.office.project.server.webservices.Project.QueueCreateProjectDataset dataset, boolean validateOnly) throws java.rmi.RemoteException{
    if (projectSoap == null)
      _initProjectSoapProxy();
    projectSoap.queueCreateProject(jobUid, dataset, validateOnly);
  }
  
  public void queueCreateProjectAndCheckOut(java.lang.String jobUid, java.lang.String sessionUid, java.lang.String sessionDescription, com.microsoft.schemas.office.project.server.webservices.Project.QueueCreateProjectAndCheckOutDataset dataset, boolean validateOnly) throws java.rmi.RemoteException{
    if (projectSoap == null)
      _initProjectSoapProxy();
    projectSoap.queueCreateProjectAndCheckOut(jobUid, sessionUid, sessionDescription, dataset, validateOnly);
  }
  
  public void queueAddToProject(java.lang.String jobUid, java.lang.String sessionUid, com.microsoft.schemas.office.project.server.webservices.Project.QueueAddToProjectDataset dataset, boolean validateOnly) throws java.rmi.RemoteException{
    if (projectSoap == null)
      _initProjectSoapProxy();
    projectSoap.queueAddToProject(jobUid, sessionUid, dataset, validateOnly);
  }
  
  public java.lang.String createProjectFromTemplate(java.lang.String templateUid, java.lang.String projectName) throws java.rmi.RemoteException{
    if (projectSoap == null)
      _initProjectSoapProxy();
    return projectSoap.createProjectFromTemplate(templateUid, projectName);
  }
  
  public void queueDeleteProjects(java.lang.String jobUid, boolean deleteWSS, java.lang.String[] projectUids, boolean deleteBoth) throws java.rmi.RemoteException{
    if (projectSoap == null)
      _initProjectSoapProxy();
    projectSoap.queueDeleteProjects(jobUid, deleteWSS, projectUids, deleteBoth);
  }
  
  public void queueRenameProject(java.lang.String jobUid, java.lang.String sessionUid, java.lang.String projectUid, java.lang.String name) throws java.rmi.RemoteException{
    if (projectSoap == null)
      _initProjectSoapProxy();
    projectSoap.queueRenameProject(jobUid, sessionUid, projectUid, name);
  }
  
  public com.microsoft.schemas.office.project.server.webservices.Project.ReadProjectResponseReadProjectResult readProject(java.lang.String projectUid, com.microsoft.schemas.office.project.server.webservices.Project.DataStoreEnum dataStore) throws java.rmi.RemoteException{
    if (projectSoap == null)
      _initProjectSoapProxy();
    return projectSoap.readProject(projectUid, dataStore);
  }
  
  public com.microsoft.schemas.office.project.server.webservices.Project.ReadProjectEntitiesResponseReadProjectEntitiesResult readProjectEntities(java.lang.String projectUid, int projectEntityType, com.microsoft.schemas.office.project.server.webservices.Project.DataStoreEnum dataStore) throws java.rmi.RemoteException{
    if (projectSoap == null)
      _initProjectSoapProxy();
    return projectSoap.readProjectEntities(projectUid, projectEntityType, dataStore);
  }
  
  public void queueUpdateProject(java.lang.String jobUid, java.lang.String sessionUid, com.microsoft.schemas.office.project.server.webservices.Project.QueueUpdateProjectDataset dataset, boolean validateOnly) throws java.rmi.RemoteException{
    if (projectSoap == null)
      _initProjectSoapProxy();
    projectSoap.queueUpdateProject(jobUid, sessionUid, dataset, validateOnly);
  }
  
  public void queueDeleteFromProject(java.lang.String jobUid, java.lang.String sessionUid, java.lang.String projectUid, java.lang.String[] projectEntityUids) throws java.rmi.RemoteException{
    if (projectSoap == null)
      _initProjectSoapProxy();
    projectSoap.queueDeleteFromProject(jobUid, sessionUid, projectUid, projectEntityUids);
  }
  
  public com.microsoft.schemas.office.project.server.webservices.Project.ReadProjectTeamResponseReadProjectTeamResult readProjectTeam(java.lang.String projectUid) throws java.rmi.RemoteException{
    if (projectSoap == null)
      _initProjectSoapProxy();
    return projectSoap.readProjectTeam(projectUid);
  }
  
  public void queueUpdateProjectTeam(java.lang.String jobUid, java.lang.String sessionUid, java.lang.String projectUid, com.microsoft.schemas.office.project.server.webservices.Project.QueueUpdateProjectTeamDataset dataset) throws java.rmi.RemoteException{
    if (projectSoap == null)
      _initProjectSoapProxy();
    projectSoap.queueUpdateProjectTeam(jobUid, sessionUid, projectUid, dataset);
  }
  
  public com.microsoft.schemas.office.project.server.webservices.Project.ReadSchedulingContextResponseReadSchedulingContextResult readSchedulingContext(java.lang.String[] projectUids, java.lang.String[] resourceUids) throws java.rmi.RemoteException{
    if (projectSoap == null)
      _initProjectSoapProxy();
    return projectSoap.readSchedulingContext(projectUids, resourceUids);
  }
  
  public java.lang.String getProjectNameFromProjectUid(java.lang.String projectUid, com.microsoft.schemas.office.project.server.webservices.Project.DataStoreEnum dataStore) throws java.rmi.RemoteException{
    if (projectSoap == null)
      _initProjectSoapProxy();
    return projectSoap.getProjectNameFromProjectUid(projectUid, dataStore);
  }
  
  public org.apache.axis.types.UnsignedShort readServerListSeparator() throws java.rmi.RemoteException{
    if (projectSoap == null)
      _initProjectSoapProxy();
    return projectSoap.readServerListSeparator();
  }
  
  public com.microsoft.schemas.office.project.server.webservices.Project.ReadProjectStatusResponseReadProjectStatusResult readProjectStatus(java.lang.String projGuid, com.microsoft.schemas.office.project.server.webservices.Project.DataStoreEnum dataStore, java.lang.String projName, int projType) throws java.rmi.RemoteException{
    if (projectSoap == null)
      _initProjectSoapProxy();
    return projectSoap.readProjectStatus(projGuid, dataStore, projName, projType);
  }
  
  public com.microsoft.schemas.office.project.server.webservices.Project.QueuePublishResponseQueuePublishResult queuePublish(java.lang.String jobUid, java.lang.String projectUid, boolean fullPublish, java.lang.String wssURL) throws java.rmi.RemoteException{
    if (projectSoap == null)
      _initProjectSoapProxy();
    return projectSoap.queuePublish(jobUid, projectUid, fullPublish, wssURL);
  }
  
  public void queueUpgradeProject(java.lang.String projectUID) throws java.rmi.RemoteException{
    if (projectSoap == null)
      _initProjectSoapProxy();
    projectSoap.queueUpgradeProject(projectUID);
  }
  
  public void queueCreateProposalProjectAndCheckout(java.lang.String jobUid, java.lang.String sessionUid, java.lang.String sessionDescription, com.microsoft.schemas.office.project.server.webservices.Project.QueueCreateProposalProjectAndCheckoutProjDS projDS, boolean validateOnly, boolean publishProject) throws java.rmi.RemoteException{
    if (projectSoap == null)
      _initProjectSoapProxy();
    projectSoap.queueCreateProposalProjectAndCheckout(jobUid, sessionUid, sessionDescription, projDS, validateOnly, publishProject);
  }
  
  public java.lang.String createOperationsWorkFromWssList(java.lang.String sessionUid, java.lang.String listDataXml, java.lang.String priorityMappingsXml, java.lang.String projectName, java.lang.String projectDescription, java.lang.String titleFieldName, java.lang.String startDateFieldName, java.lang.String finishDateFieldName, java.lang.String taskPriorityFieldName, java.lang.String percentCompleteFieldName, java.lang.String resourceFieldName, boolean includeWorkflow) throws java.rmi.RemoteException{
    if (projectSoap == null)
      _initProjectSoapProxy();
    return projectSoap.createOperationsWorkFromWssList(sessionUid, listDataXml, priorityMappingsXml, projectName, projectDescription, titleFieldName, startDateFieldName, finishDateFieldName, taskPriorityFieldName, percentCompleteFieldName, resourceFieldName, includeWorkflow);
  }
  
  public void updateProjectWorkspaceAddress(java.lang.String projectUid, java.lang.String newWebName, java.lang.String newWSSServerUID) throws java.rmi.RemoteException{
    if (projectSoap == null)
      _initProjectSoapProxy();
    projectSoap.updateProjectWorkspaceAddress(projectUid, newWebName, newWSSServerUID);
  }
  
  public com.microsoft.schemas.office.project.server.webservices.Project.ReadProjectListResponseReadProjectListResult readProjectList() throws java.rmi.RemoteException{
    if (projectSoap == null)
      _initProjectSoapProxy();
    return projectSoap.readProjectList();
  }
  
  public void queueSynchronizeProjectWorkspace(java.lang.String jobUid, java.lang.String projectUid, boolean forceFullSync) throws java.rmi.RemoteException{
    if (projectSoap == null)
      _initProjectSoapProxy();
    projectSoap.queueSynchronizeProjectWorkspace(jobUid, projectUid, forceFullSync);
  }
  
  
}